/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.s4s.gui.views;

import com.vaadin.navigator.ViewChangeListener;
import com.vaadin.server.VaadinSession;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.Notification;
import com.vaadin.ui.Panel;
import com.vaadin.ui.Table;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;
import java.util.HashSet;
import java.util.Set;
import org.s4s.modell.dto.Product;
import org.s4s.modell.dto.Warenkorb;
import org.s4s.services.util.Roles;
import org.s4s.services.util.Views;

/**
 *
 * @author Holger
 */
public class WarenkorbView extends TemplateView {

    private final Warenkorb warenkorb = Warenkorb.getInstance();
    private VaadinSession session = UI.getCurrent().getSession();

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent event) {
        this.setUp();
    }

    public void setUp() {
        VaadinSession session = UI.getCurrent().getSession();
        if (session.getAttribute(Roles.CURRENTUSER) == null) {
            UI.getCurrent().getNavigator().navigateTo(Views.LOGIN);
            Notification.show(null, "Einloggen, um auf den Warenkorb zuzugreifen!", Notification.Type.WARNING_MESSAGE);
        }

        final VerticalLayout contentLayout = new VerticalLayout();
        super.setUpFooterAndHeader(contentLayout);

        if (warenkorb.getAnzahl() == 0) {
            Panel panel = new Panel("Der Warenkorb ist leer!");
            this.addComponent(panel);
            this.setComponentAlignment(panel, Alignment.TOP_LEFT);
        } else {
            Panel pAnzahl = new Panel("In Ihrem Warenkorb sind momentan: " + warenkorb.getAnzahl() + " Artikel!");
            this.addComponent(pAnzahl);
            this.setComponentAlignment(pAnzahl, Alignment.TOP_LEFT);

            Panel pSum = new Panel("Gesamtwert im Warenkorb beträgt: " + warenkorb.sum());
            this.addComponent(pSum);
            this.setComponentAlignment(pSum, Alignment.TOP_RIGHT);
            warenkorb.auflisten();
            final Table table = new Table("Ihr Warenkorb");
            table.addContainerProperty("Bezeichnung", String.class, null);
            table.addContainerProperty("Preis", Double.class, null);
            table.addContainerProperty("Menge", Integer.class, null);
            // table.setSizeFull();
            // table.setSelectable(true);
            addComponent(table);
            Set<Product> liste = new HashSet<>();
            liste.addAll(warenkorb.inhalt());
            //data.addAll(liste);
            this.setComponentAlignment(table, Alignment.TOP_CENTER);
        }
    }
}
